Loading...
Searching...
No Matches
Sip_www_authenticate

## Macros

#define | sip_www_authenticate(sip)
| Access a SIP WWW-Authenticate header structure sip_www_authenticate_t from sip_t.
#define | SIP_WWW_AUTHENTICATE_INIT()
| Initializer for structure sip_www_authenticate_t.
#define | SIPTAG_WWW_AUTHENTICATE(x)
| Tag list item for pointer to a WWW-Authenticate header structure sip_www_authenticate_t.
#define | SIPTAG_WWW_AUTHENTICATE_REF(x)
| Tag list item for reference to a WWW-Authenticate header pointer.
#define | SIPTAG_WWW_AUTHENTICATE_STR(s)
| Tag list item for string with WWW-Authenticate header value.
#define | SIPTAG_WWW_AUTHENTICATE_STR_REF(x)
| Tag list item for reference to a WWW-Authenticate header string.

## Typedefs

typedef struct msg_auth_s | sip_www_authenticate_t
| @

## Functions

issize_t | sip_www_authenticate_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP WWW-Authenticate header.
issize_t | sip_www_authenticate_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP WWW-Authenticate header.
sip_www_authenticate_t * | sip_www_authenticate_init (sip_www_authenticate_t x[1])
| Initialize a structure sip_www_authenticate_t.
int | sip_is_www_authenticate (sip_header_t const *header)
| Test if header object is instance of sip_www_authenticate_t.
sip_www_authenticate_t * | sip_www_authenticate_dup (su_home_t *home, sip_www_authenticate_t const *hdr))
| Duplicate a list of WWW-Authenticate header header structures sip_www_authenticate_t.
sip_www_authenticate_t * | sip_www_authenticate_copy (su_home_t *home, sip_www_authenticate_t const *hdr))
| Copy a list of WWW-Authenticate header header structures sip_www_authenticate_t.
sip_www_authenticate_t * | sip_www_authenticate_make (su_home_t *home, char const *s))
| Make a WWW-Authenticate header structure sip_www_authenticate_t.
sip_www_authenticate_t * | sip_www_authenticate_format (su_home_t *home, char const *fmt,...)))
| Make a WWW-Authenticate header from formatting result.

## Variables

msg_hclass_t | sip_www_authenticate_class []
| Header class for WWW-Authenticate header.
tag_typedef_t | siptag_www_authenticate
| Tag for WWW-Authenticate header object.
tag_typedef_t | siptag_www_authenticate_str
| Tag for string with WWW-Authenticate header value.

## Detailed Description

## Macro Definition Documentation

## SIP_WWW_AUTHENTICATE_INIT

#define SIP_WWW_AUTHENTICATE_INIT | ( |  | ) |

Initializer for structure sip_www_authenticate_t.

A static sip_www_authenticate_t structure for WWW-Authenticate header must be initialized with the SIP_WWW_AUTHENTICATE_INIT() macro. For instance,

sip_www_authenticate_t sip_www_authenticate = SIP_WWW_AUTHENTICATE_INIT;
sip_www_authenticate_t
struct msg_auth_s sip_www_authenticate_t
@
Definition sip.h:202
sip_www_authenticate
#define sip_www_authenticate(sip)
Access a SIP WWW-Authenticate header structure sip_www_authenticate_t from sip_t.
Definition sip_protos.h:10365
SIP_WWW_AUTHENTICATE_INIT
#define SIP_WWW_AUTHENTICATE_INIT()
Initializer for structure sip_www_authenticate_t.
Definition sip_protos.h:10382

## SIPTAG_WWW_AUTHENTICATE

#define SIPTAG_WWW_AUTHENTICATE | ( |  | x | ) |

Tag list item for pointer to a WWW-Authenticate header structure sip_www_authenticate_t.

The SIPTAG_WWW_AUTHENTICATE() macro is used to include a tag item with a pointer to a sip_www_authenticate_t structure in a tag list.

Parameters

  x | pointer to a sip_www_authenticate_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_WWW_AUTHENTICATE_REF().

## SIPTAG_WWW_AUTHENTICATE_STR

#define SIPTAG_WWW_AUTHENTICATE_STR | ( |  | s | ) |

Tag list item for string with WWW-Authenticate header value.

The SIPTAG_WWW_AUTHENTICATE_STR() macro is used to include a tag item with a string containing value of a sip_www_authenticate_t header in a tag list.

Parameters

  s | pointer to a string containing WWW-Authenticate header value, or NULL.

The string in SIPTAG_WWW_AUTHENTICATE_STR() can be converted to a sip_www_authenticate_t header structure by giving the string s has second argument to function sip_www_authenticate_make().

The corresponding tag taking reference parameter is SIPTAG_WWW_AUTHENTICATE_STR_REF().

## Typedef Documentation

## sip_www_authenticate_t

typedef struct msg_auth_s sip_www_authenticate_t

@

The WWW-Authenticate header consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the Request-URI. Its syntax is defined in RFC 3261 as follows:

WWW-Authenticate = "WWW-Authenticate" HCOLON challenge
challenge = ("Digest" LWS digest-cln *(COMMA digest-cln))
/ other-challenge
other-challenge = auth-scheme LWS auth-param *(COMMA auth-param)
LWS
#define LWS

See Proxy-Authenticate for the definition of <digest-cln>.

The parsed WWW-Authenticate header is stored in sip_www_authenticate_t structure.

The structure sip_www_authenticate_t contains representation of SIP WWW-Authenticate header.

The sip_www_authenticate_t is defined as follows:

typedef struct msg_auth_s {
msg_common_t au_common[1]; // Common fragment info
msg_auth_t *au_next; // Link to next header
char const *au_scheme; // Auth-scheme like "Basic" or "Digest"
msg_param_t const *au_params; // Comma-separated parameters
} sip_www_authenticate_t;
msg_common_t
struct msg_common_s msg_common_t
msg_auth_s
msg_auth_s::au_scheme
char const * au_scheme
msg_auth_s::au_params
msg_param_t const * au_params
msg_auth_s::au_next
msg_auth_t * au_next
msg_auth_s::au_common
msg_common_t au_common[1]

## Function Documentation

## sip_is_www_authenticate()

int sip_is_www_authenticate | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_www_authenticate_t.

Check if the header class is an instance of WWW-Authenticate header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header www_authenticate
  0 | (false) otherwise

## sip_www_authenticate_copy()

sip_www_authenticate_t * sip_www_authenticate_copy | ( | su_home_t * | home,
|  | sip_www_authenticate_t const * | hdr )

inline

Copy a list of WWW-Authenticate header header structures sip_www_authenticate_t.

The function sip_www_authenticate_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  www_authenticate = sip_www_authenticate_copy(home, sip->sip_www_authenticate);
  sip_www_authenticate_copy
  sip_www_authenticate_t * sip_www_authenticate_copy(su_home_t *home, sip_www_authenticate_t const *hdr))
  Copy a list of WWW-Authenticate header header structures sip_www_authenticate_t.
  Definition sip_protos.h:10512

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_www_authenticate_dup()

sip_www_authenticate_t * sip_www_authenticate_dup | ( | su_home_t * | home,
|  | sip_www_authenticate_t const * | hdr )

inline

Duplicate a list of WWW-Authenticate header header structures sip_www_authenticate_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  www_authenticate = sip_www_authenticate_dup(home, sip->sip_www_authenticate);
  sip_www_authenticate_dup
  sip_www_authenticate_t * sip_www_authenticate_dup(su_home_t *home, sip_www_authenticate_t const *hdr))
  Duplicate a list of WWW-Authenticate header header structures sip_www_authenticate_t.
  Definition sip_protos.h:10469

Returns
  A pointer to the newly duplicated sip_www_authenticate_t header structure, or NULL upon an error.

## sip_www_authenticate_format()

sip_www_authenticate_t * sip_www_authenticate_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a WWW-Authenticate header from formatting result.

Make a new sip_www_authenticate_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_www_authenticate_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_www_authenticate_init()

sip_www_authenticate_t * sip_www_authenticate_init | ( | sip_www_authenticate_t | x[1] | ) |

inline

Initialize a structure sip_www_authenticate_t.

An sip_www_authenticate_t structure for WWW-Authenticate header can be initialized with the sip_www_authenticate_init() function/macro. For instance,

sip_www_authenticate_t sip_www_authenticate;
sip_www_authenticate_init(&sip_www_authenticate);
sip_www_authenticate_init
sip_www_authenticate_t * sip_www_authenticate_init(sip_www_authenticate_t x[1])
Initialize a structure sip_www_authenticate_t.
Definition sip_protos.h:10400

## sip_www_authenticate_make()

sip_www_authenticate_t * sip_www_authenticate_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a WWW-Authenticate header structure sip_www_authenticate_t.

The function sip_www_authenticate_make() makes a new sip_www_authenticate_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_www_authenticate_t header structure, or NULL upon an error.

## Variable Documentation

## sip_www_authenticate_class

msg_hclass_t sip_www_authenticate_class[]

extern

Header class for WWW-Authenticate header.

The header class sip_www_authenticate_class defines how a SIP WWW-Authenticate header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_www_authenticate_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.